package help

import (
	"git.lxtend.com/qqbot/action"
	"git.lxtend.com/qqbot/constants"
	"git.lxtend.com/qqbot/handler"
	"git.lxtend.com/qqbot/message"
	"git.lxtend.com/qqbot/model"
	"git.lxtend.com/qqbot/util"
)

func init() {
	handler.RegisterHandler("!help", help, constants.LEVEL_BANNED)
}

func help(msg model.Message) *model.Reply {
	var helpInfo string
	if len(util.SplitN(msg.RawMsg, 2)) == 1 {
		helpInfo = `请输入!help [分类] 查看下面的分类功能`
		for k := range handler.HelpInforms {
			helpInfo += "\n" + k
		}
		helpInfo += "\n" + "新功能请求请移步https://git.lxtend.com/lixiangwuxian/qq_bot/issues"
	} else {
		category := util.SplitN(msg.RawMsg, 2)[1]
		helpInfos := handler.HelpInforms[category]
		helpInfo = `以下是` + category + `的功能：`
		for _, v := range helpInfos {
			helpInfo += "\n" + v.Trigger + " : " + v.Inform
		}
	}
	textMsg := message.NewTextMessage()
	textMsg.Data.Text = helpInfo
	nodeMsg := message.NewNodeMessage()
	nodeMsg.Data.ID = "10086"
	nodeMsg.Data.UserID = "123456789"
	nodeMsg.Data.Nickname = "test"
	nodeMsg.Data.Content = []any{&textMsg}
	action.ActionManager.SendForward(&model.Reply{
		ReplyMsg:       []any{&nodeMsg},
		ReferOriginMsg: false,
		FromMsg:        msg,
	})
	return nil
}
